#!/usr/bin/perl

################################ Reads Inoput Data ##############################
use Getopt::Std;
getopts('i:t:o:');
$infile=$opt_i;
$outfile=$opt_o;
$thr = $opt_t;

if($infile eq "" or $outfile eq "")
{
    print "perl RNAcon.pl -i input_RNA_fasta_file -t svm_threshold -o output_file\n";
    exit;
}

##############ACTUAL PROCESS BEGINS FROM HERE#######################
#system "rm -rf /gpsr/temp/rnacon/rnacon*";

open(fp11,">>Random");
$ran= int(rand 10000);
print fp11 "rnacon$ran\n";
$dir = "rnacon$ran";
system "mkdir $dir";
system "mkdir $dir/graph $dir/structure $dir/fasta";
system "chmod 755 $dir $dir/graph $dir/structure $dir/fasta";

system "/usr/bin/dos2unix -k -n $infile $dir/seq.unix";
system "/usr/bin/perl ./progs/fasta.pl $dir/seq.unix $dir/seq.unix2";
system "cp $dir/seq.unix2 $dir/fasta/seq.fasta";

############# start  ###############################

open(FH2,">$outfile") or die "$!";

print FH2 "\nPrediction result for job number -  RNAcon-$ran\n";
print FH2 "SVM Threshold Selected = $thr\n";

system "/usr/bin/perl ./progs/sfasta.pl $dir/seq.unix $dir/final_file";

################# Actual Prediction ############################

system "/usr/bin/perl ./progs/nuc2tnc.pl -i $dir/final_file -o $dir/pred.tc";
system "/usr/bin/perl ./progs/col2svm.pl -i $dir/pred.tc -o $dir/pred.svm -s 0";
$res = `./progs/svm_classify $dir/pred.svm ./models/MODEL-TRINC $dir/pred.score`;

################################################# Classification ######################################

system "./progs/ipknot -b $dir/seq.unix2 > $dir/seq.ip"; ## set path of IPknot
system "/usr/bin/perl -p -e \"s/\#/>/g\" $dir/seq.ip > $dir/structure/seq.out";
system "/usr/bin/Rscript ./progs/IPKnotGraph2-BPSEQ.R $dir"; ## please set path of Rscript
system "/usr/bin/perl ./progs/col2svm.pl -i $dir/graph/seq_graph.csv -o $dir/class.svm -s 0";
system "/usr/bin/perl ./progs/svm2Weka.pl $dir/class.svm > $dir/test.arff";

#system "java -cp ./progs/weka.jar weka.classifiers.trees.RandomForest -l ./models/RF-MODEL -T $dir/test.arff -i -p 0 -distribution >> $dir/class.result";

system "java -Xmx2000m -cp ./progs/weka.jar weka.classifiers.trees.RandomForest -l ./models/RF-MODEL -T $dir/test.arff -i -p 0 -distribution >> $dir/class.result"; ## This option require 2GB RAM of the system

############### Highgraphs ####################################

system "/usr/bin/perl ./progs/class.pl $ran";

############### VARNA ########################################

system "/usr/bin/perl ./progs/structure.pl $ran";

system "paste $dir/pred.score $dir/class.score > $dir/scores";

####################################################################################################

open(KT,"$dir/scores");
open(KA,">$dir/res.out");
open(AK,">$dir/resc.out");

$i=0;
$i1=0;

while($fff=<KT>)
{  
    chomp($fff);

    @ff = split(/\t/,$fff);
    $kh = $ff[0]-$thres_svm;

#    while($ccc=<TK>){ chomp($ccc);
    if($ff[0] >= $thres_svm)
    {
	$i++;
        print KA "Non-coding RNA (";
	printf KA "%3.2f",$kh;
	print KA ")\n";
	print AK "$ff[1]\n";
    }
  #print "TP:$i\n";
    else
{
    $i1++;

    print KA "Coding RNA (";
    printf KA "%3.2f",$kh;
    print KA ")\n";

    print AK "No-Class\n";
}
}

close KT;
close KA;
close AK;

##############################################################################################

open(FP1,"$dir/seq.unix");
open(FP4,">$dir/seqname");

while($tt=<FP1>){
   # print "$tt";
    chomp($tt);
    if($tt=~/^>/)
{
    @nn=split(/\ /,$tt);
    $nn[0] =~ s/>//;
    print FP4 "$nn[0]\n";      
}
}
close FP1;
close FP4;

print FH2 "Total numder of predicted ncRNAs : $i\n";
print FH2 "Total number of predicted coding RNAs : $i1\n\n";
print FH2 "Input\t\t\tPrediction\t\t\tClassification\n\n";

open(FP4,"$dir/seqname");
@name= <FP4>;

open(KA,"$dir/res.out");
@final1= <KA>;

open(AK,"$dir/resc.out");
@final1c= <AK>;

for($c=0;$c<@name;$c++){$d=$c+1;

if ($final1c[$c] =~ "No-Class"){
    chomp($name[$c]);
    chomp($final1[$c]);

    print FH2 "$d. $name[$c]\t\t\t$final1[$c]\t\t\tmRNA\n";
}
else{
    chomp($name[$c]);
    chomp($final1[$c]);
    chomp($final1c[$c]);
    print FH2 "$d. $name[$c]\t\t\t$final1[$c]\t\t\t$final1c[$c]\n";
}

}

##################################################################################################
close FH2;
close FP4;    
close KA;
close AK;
####################################################################################################
