#!/usr/bin/perl

################################ Reads Inoput Data ##############################
use Getopt::Std;
getopts('i:t:o:');
$infile=$opt_i;
$outfile=$opt_o;
$thr = $opt_t;

if($infile eq "" or $outfile eq "")
{
    print "perl RNAcon_predict.pl -i input_RNA_fasta_file -t svm_threshold -o output_file\n";
    exit;
}

##############ACTUAL PROCESS BEGINS FROM HERE#######################
#system "rm -rf /gpsr/temp/rnacon/rnacon*";

open(fp11,">>Random");
$ran= int(rand 10000);
print fp11 "rnacon$ran\n";
$dir = "rnacon$ran";
system "mkdir $dir";
system "mkdir $dir/graph $dir/structure $dir/fasta";
system "chmod 755 $dir $dir/graph $dir/structure $dir/fasta";

system "/usr/bin/dos2unix -k -n $infile $dir/seq.unix";
system "cp $dir/seq.unix $dir/fasta/seq.fasta";

############# start  ###############################

open(FH2,">$outfile") or die "$!";

print FH2 "\nPrediction result for job number -  RNAcon-$ran\n";
print FH2 "SVM Threshold Selected = $thr\n";

system "/usr/bin/perl ./progs/sfasta.pl $dir/seq.unix $dir/final_file";

################# Actual Prediction ############################

system "/usr/bin/perl ./progs/nuc2tnc.pl -i $dir/final_file -o $dir/pred.tc";
system "/usr/bin/perl ./progs/col2svm.pl -i $dir/pred.tc -o $dir/pred.svm -s 0";
$res = `./progs/svm_classify $dir/pred.svm ./models/MODEL-TRINC $dir/pred.score`;

####################################################################################################

open(KT,"$dir/pred.score");
open(KA,">$dir/res.out");

$i=0;
$i1=0;

while($fff=<KT>)
{  
    chomp($fff);

    $kh = $fff-$thres_svm;

    if($fff >= $thres_svm)
    {
	$i++;
        print KA "Non-coding RNA (";
	printf KA "%3.2f",$kh;
	print KA ")\n";
    }

    else
{
    $i1++;

    print KA "Coding RNA (";
    printf KA "%3.2f",$kh;
    print KA ")\n";
}
}

close KT;
close KA;

##############################################################################################

open(FP1,"$dir/seq.unix");
open(FP4,">$dir/seqname");

while($tt=<FP1>){
   # print "$tt";
    chomp($tt);
    if($tt=~/^>/)
{
    @nn=split(/\ /,$tt);
    $nn[0] =~ s/>//;
    print FP4 "$nn[0]\n";      
}
}
close FP1;
close FP4;

print FH2 "Total numder of predicted ncRNAs : $i\n";
print FH2 "Total number of predicted coding RNAs : $i1\n\n";
print FH2 "Input\t\t\tPrediction\n\n";

open(FP4,"$dir/seqname");
@name= <FP4>;

open(KA,"$dir/res.out");
@final1= <KA>;


for($c=0;$c<@name;$c++){$d=$c+1;

    chomp($name[$c]);
    chomp($final1[$c]);

    print FH2 "$d. $name[$c]\t\t\t$final1[$c]\n";

}

##################################################################################################
close FH2;
close FP4;    
close KA;
####################################################################################################
